<?
$mainGUI = &GUIFactory::setMainGUI( "main" );

node_include("load_menu");
mysession_var_reg("CR_ID");
load_menu(15214,T_CONTENTREPOSITORY,$CR_ID);

$ASSCORE = str_replace("\r","",str_replace("\n","<br>", i18n("assign nodes contentrepositories assistant")));






class FloatComponent extends CollectionComponent {
 var $m_valign = array();

 function FloatComponent($label = null) {
 parent::CollectionComponent($label);
 }

 function getSerializeKey() {
 $rs = array();
 $rs["parent"] = parent::getSerializeKey();
 $rs["valign"] = node_serialize( $this->m_valign );
 return $rs;
 }
 
 function initFromSerializeKey( $rs ) {
 parent::initFromSerializeKey( $rs["parent"] );
 $this->m_valign =&node_unserialize( $rs["valign"] );
 }

 function setComponent($key, &$component, $afterComponent = false, $valign = "top") {
 parent::setComponent($key, &$component, $afterComponent);
 $this->m_valign[$key] = $valign;
 }

 function getHTML(&$form, $prefix, $doCheck, $checkSeverity, $key ) {
 $htmlAdd = $this->_getComponentHTML( $this->getComponents(), $form, $prefix, $doCheck, $checkSeverity, $key );
 $html .= "<table>";
 $html .= "<tr>";
 foreach ( $htmlAdd as $key => $ele) {
 $html .= "<th><nobr>".(is_array($ele)?$ele[0]:"")."</nobr></th>";
 }
 $html .= "</tr>";
 $html .= "<tr>";
 foreach( $htmlAdd as $key=>$ele) {

 $html .= "<td valign='".$this->m_valign[$key]."' width=30px>".(is_array($ele)?$ele[1]:$ele)."</td>";
 }
 $html .= "</tr></table>";
 return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
 }
}

class DisabledNodesFormatter extends ResultsetFormatter {

 function format( $row ) {
 if (!$row["publish_contentmap"]) {
 return "<i>(".$row["name"].")*</i>";
 } else {
 return $row["name"];
 }
 }
}











function printError($message) {
?>
<script type="text/javascript">
alert('<?php echo $message; ?>');
</script>
<?
}

function unlink_node($node_id) {
 global $CR_ID;
 cmd_unlink_node($CR_ID, $node_id);
}

function assign_node($node_id) {
 global $CR_ID, $FEATURE;

 
 if ($FEATURE["multichannelling"] && $FEATURE["multichannelling_contentrepository"]) {
 $res = query("select n.id, f.name, n.contentrepository_id from node n left join folder f on f.node_id = n.id where f.channelset_id in (select f.channelset_id from node n left join folder f on f.node_id = n.id where n.id = " . sqlslashes($node_id) . ") and n.contentrepository_id is not NULL and n.contentrepository_id != 0 and f.is_master = 0;");
 if ($res["num"] > 0) {
 global $REDO, $cr_node_id;
 $cr_node_id = $node_id;
 $REDO = 15219;
 return;
 }
 }
 $assignErrorMsg = cmd_assign_node($CR_ID, $node_id);

 if ($assignErrorMsg !== true) {
 printError($assignErrorMsg);
 }
}


if ($btnassign_x) {
 $I3_cr_unassigned_nodes_list_pt = "action";
 $I3_cr_unassigned_nodes_list_pv = "assign";
}
if ($btunnassign_x) {
 $I3_cr_assigned_nodes_list_pt = "action";
 $I3_cr_assigned_nodes_list_pv = "delete";
}

$cr_nodes = new HtmlForm3("cr_node");
if ($cr_nodes->isNew()) {
 $contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $CR_ID);
 $allowedit = perm($USER_ID, T_CONTENTREPOSITORY, $CR_ID, 2);

 $cr_nodes->setHeader(i18n("Assign Nodes to ContentRepository {0}", 0, $contentrepository->getFieldValue("name")));

 $main = new ListComponent();

 $float = new FloatComponent();
 $main->setComponent("float", $float);
 $main->setComponent("label", new LabelComponent(null,
 "<i>*".i18n("Italic nodes have publishing into the contentrepository disabled!")."</i>"
 . "<br /><br />"
 . i18n("assign_nodes_to_cr_permission_infotext")
 , true));

 $isMCCR = $contentrepository->getFieldValue("multichannelling");
 
 $mccrFilterCondition = '';
 if ($FEATURE['multichannelling'] && $FEATURE['multichannelling_contentrepository'] && $isMCCR) {
 $mccrFilterCondition = ' and folder.is_master = 1';
 }

 $unassigned_ds = new SQLDatasource( 'cr_unassigned_nodes_sql', 'node.id, folder.name, folder.name rawname, folder_id, publish_contentmap, if(is_master, folder_id, master_id) perm_folder_id', 'node left join folder on node.folder_id = folder.id', '(node.contentrepository_id = 0 or node.contentrepository_id is null)' . $mccrFilterCondition);
 $unassigned_ds->setDBHandle( $DB );
 $unassigned_ds->addColumn("name", i18n("Name"), true, true, true);
 $unassigned_ds->addAction( new CommandAction( null, 'assign', i18n('Assign to ContentRepository'), "assign_node") );
 
 $unassigned_ds->setPermInfo($T_DOMAIN, 9, "perm_folder_id"); 
 $unassigned_ds->addFormatter("name", new DisabledNodesFormatter());

 $unassigned_list = new ItemList3("cr_unassigned_nodes_list", $unassigned_ds );
 $unassigned_list->setNoHeader(true);
 $float->setComponent('cr_unassigned_nodes', $comp = new ItemListComponent( i18n("Unassigned Nodes"), $unassigned_list ) );
 $comp->setOptional(true);

 
 $right_arrows = urlencode(base64_encode('>>'));
 $left_arrows = urlencode(base64_encode('<<'));
 
 
 $float->setComponent('assign_button', $comp = new LabelComponent(null,
 "<input onclick=\"return confirm('".i18n('are_you_sure_you_want_to')."... ".i18n("Assign to ContentRepository")."')\" name=\"btnassign\" src=\"?do=15&amp;text=$right_arrows&amp;encoding=base64\" title=\"".i18n("Assign to ContentRepository")."\" alt=\"".i18n("Assign to ContentRepository")."\" border=\"0\" type=\"image\"><br/>".
 "<input onclick=\"return confirm('".i18n('are_you_sure_you_want_to')."... ".i18n("Delete from ContentRepository")."')\" name=\"btunnassign\" src=\"?do=15&amp;text=$left_arrows&amp;encoding=base64\" title=\"".i18n("Delete from ContentRepository")."\" alt=\"".i18n("Delete from ContentRepository")."\" border=\"0\" type=\"image\">", true), false, "middle");

 
 $assigned_ds = new SQLDatasource( 'cr_assigned_nodes_sql', 'node.id, folder.name, folder.name rawname, folder_id, publish_contentmap, if(is_master, folder_id, master_id) perm_folder_id', 'node left join folder on node.folder_id = folder.id', "node.contentrepository_id = ".sqlf_tl_num($CR_ID) . $mccrFilterCondition);
 $assigned_ds->setDBHandle( $DB );
 $assigned_ds->addColumn("name", i18n("Name"), true, true, true);
 $assigned_ds->addAction( new CommandAction( $ICO_DELETE, 'delete', i18n('Delete from ContentRepository'), "unlink_node") );
 
 $assigned_ds->setPermInfo($T_DOMAIN, 9, "perm_folder_id"); 
 $assigned_ds->addFormatter("name", new DisabledNodesFormatter());

 $assigned_list = new ItemList3("cr_assigned_nodes_list", $assigned_ds );
 $assigned_list->setNoHeader(true);
 $float->setComponent('cr_assigned_nodes', $comp = new ItemListComponent( i18n("Assigned Nodes"), $assigned_list ) );
 $comp->setOptional(true);

 $float->m_valign = array("top", "top", "top", "middle", "top", "top");

 $cr_nodes->addComponent( 'main', $main );
} else {
 $listcomp = & $cr_nodes->resolveComponent( 'main.float.cr_unassigned_nodes' );
 $itemlist3 = & $listcomp->getList();
 $ds = & $itemlist3->getDatasource();
 $ds->setDBHandle( $DB );

 $listcomp = & $cr_nodes->resolveComponent( 'main.float.cr_assigned_nodes' );
 $itemlist3 = & $listcomp->getList();
 $ds = & $itemlist3->getDatasource();
 $ds->setDBHandle( $DB );
}
?>
