<?php
$mainGui =& GUIFactory::setMainGUI("main");
$mainGui->includeJS("jquery");

node_include("form_do");
node_include("get_info");
node_include("tag_copy");
node_include("page_status");
node_class("textcomponent");
node_class("checkboxcomponent");

function createLangs( &$form, $param ) {
 global $TIME, $USER_ID, $NODE_ID, $FEATURE;

 
 $tpComp = $form->getComponent("targetPages");
 $tlComp = $form->getComponent("targetLangsAvailable");
 $pages = explode(",", $tpComp->getText());
 $langsAvailable = explode(",", $tlComp->getText());
 foreach($langsAvailable as $k => $l) {
 $c = $form->getComponent($l);
 if ($c->isChecked()) {
 $langs[$l] = $c->getSingleSelection();
 }
 }
 if (count($pages) && count($langs)) {
 while(list($k, $id) = each($pages)) {
 $page = get_pageinfo($id);

 foreach ($langs as $lk => $lv) {
 
 if (!page_lang_exists($page["id"], $lv)) {
 get_translation($id, $lv, $NODE_ID, false);

 $createdNewPage = true;
 echo "<!-- creating $lk version of " . $page["name"] . "-->\n";
 } else {
 echo "<!-- skipping $lk version of " . $page["name"] . "-->\n";
 }
 }

 
 
 
 if ($FEATURE["javaparser"] && $createdNewPage) {
 $rs = query("SELECT id FROM page WHERE contentset_id = ".$page["contentset_id"]);
 $javaParser =& CodeParser::getJavaParser();
 foreach ($rs["arr"] as $val) {
 $javaParser->clearCache(T_PAGE, $val["id"]);
 }
 }
 }
 }
}

$form = new HtmlForm3("settings");
$form->setHeader(i18n("create_translations"), 0);
if ($form->isNew()) {
 $targetPages = implode(",", sqlf_value_array(array_keys($item_id)));
 $rsCS = query("SELECT id FROM page WHERE contentgroup_id = 0 AND id IN ($targetPages)");
 if ($rsCS["num"] > 0) { 
 $form->addComponent("errCS", new LabelComponent("",i18n("qrt_pagesnocs")));
 $err = true;
 }

 
 
 $checkedNodeId = $NODE_ID;
 if ($FEATURE["multichannelling"]) {
 $checkedNodeId = getMasterNode($checkedNodeId, true);
 }

 $rs = query("SELECT c.* FROM node_contentgroup nc LEFT JOIN contentgroup c ON nc.contentgroup_id = c.id WHERE nc.node_id = ".sqlf_tl_num($checkedNodeId)." ORDER BY nc.sortorder ASC");
 if ($rs && $rs["num"] < 1) {
 $form->addComponent("err", new LabelComponent("",i18n("qrt_nodenolang")));
 $err = true;
 } 
 if (!$err) {
 $form->addComponent("info1", new LabelComponent("<img src=\"$STAG&do=11&module=content&img=doc.png\"> " . count($item_id) . " " . i18n("pages"),i18n("qrt_chooselang")));
 while (list($k, $v) = each($rs["arr"])) { 
 $form->addComponent($v["code"], new CheckboxComponent("<img src=\"$STAG&do=14203&base=doc.png&lang=" . $v["code"] . "&module=content\"> " . $v["name"], true, "", $v["id"]));
 $targetLangsAvailable[] = $v["code"];
 }

 $targetLangsAvailable = implode(",", $targetLangsAvailable);
 $form->addComponent("targetPages", new TextComponent("", false, $targetPages));
 $tps = $form->getComponent("targetPages"); $tps->setHidden(true);
 $form->addComponent("targetLangsAvailable", new TextComponent("", false, $targetLangsAvailable));
 $tls = $form->getComponent("targetLangsAvailable"); $tls->setHidden(true);
 $form->addButton("ok", new Button("Ok"), new SimpleFormAction("createLangs"), true);
 }
 $form->addButton("cancel", new Button(i18n("Cancel")), new RedoFormAction(13011), true);
} else {
 $form->removeComponents();
 $form->removeButtons();
 $form->addComponent("info", new LabelComponent("<img src=\"$STAG&do=11&module=system&img=info.gif\">",i18n("qrt_created")));
 $form->addButton("end", new Button("Ok"), new RedoFormAction(13011), true);
}

?>
