<?

GUIFactory::setMainGUI("main");

node_class("processlogger");
node_include("time_logger");
node_include("contentgroup");


if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->ping();
}

if ($ML_IMPORT_GLOBAL_TIMELIMIT) {
 set_time_limit($ML_IMPORT_GLOBAL_TIMELIMIT);
}


$logger = new ProcessLogger("import_".date("Y-m-d_H-i-s",$TIME));

$E_OK = 0;
$E_WARN = 1;
$E_ERR = 2;

$IMPORTED = array();
$CN_IMPORT_PAGES = array();
$CN_IMPORT_FOLDERS = array();


$IMPORT_DIFF = isset($import_diff) ? $import_diff : false;


$LOGLEVEL = isset($loglevel) ? $loglevel : 2;
if (!is_array($CN_IMPORT_IGNOREEXTENSION)) $CN_IMPORT_IGNOREEXTENSION = array();
if (!is_array($CN_IMPORT_USEEXTENSION)) $CN_IMPORT_USEEXTENSION = array();
if (!is_array($CN_IMPORT_PAGEEXTENSION)) $CN_IMPORT_PAGEEXTENSION = array();
$CN_IMPORT_FILES = array();


if (!isset($CN_IMPORT_PATH)) {
 $CN_IMPORT_PATH = "$FILEPATH/$MODULE/import";
}

if ($PHPSHELL && $cn_import_user_id) {
 $USER_ID = $cn_import_user_id;
 
 
 
 
 query("UPDATE systemsession set user_id = ".sql_num($USER_ID)." WHERE id = ".sql_num($SESSION_ID));
}

if ($PHPSHELL && (!$cn_import_user_id || !$cn_import_start_path || !$FOLDER_ID || !$stemplate || !$dtemplate)) {
 die(i18n("please specify at least cn_import_user_id"));
}


$perm = perm($USER_ID,$T_FOLDER, $FOLDER_ID);

if (isset($CN_IMPORT_PAGENAME)) $cn_import_pagename = $CN_IMPORT_PAGENAME;

$hi = array();

if (!$faction && !$PHPSHELL) {
 $sql = "SELECT template.id, template.name, LOWER(template.name) AS l_name FROM template, template_folder
	WHERE template.id = template_folder.template_id AND template_folder.folder_id = ".sqlf_tl_num($FOLDER_ID)."
	ORDER BY l_name";
 $rs = query($sql);
 $templates = reduce_array($rs["arr"],"id","name");
 if (!is_array($templates)) $templates = Array();
 natcasesort($templates);

 
 if ($changed) {
 $_stemplate = $f_stemplate;
 
 }

 
 if (!$f_stemplate) $f_stemplate = 0;

 if (isset($CN_IMPORT_KEEPFILENAME)) $keepfilename = $CN_IMPORT_KEEPFILENAME;
 elseif (!isset($keepfilename)) $keepfilename = 1;

 if (isset($CN_IMPORT_KEEPFOLDERS)) $keepfolders= $CN_IMPORT_KEEPFOLDERS;
 elseif (!isset($keepfolders)) $keepfolders = 0;

 if (isset($CN_IMPORT_STATUS)) $status = $CN_IMPORT_STATUS;
 elseif (!isset($status)) $status= 0;

 

 
 $tags = array();
 $sql = "SELECT id, name, LOWER(name) AS l_name 
			FROM templatetag 
			WHERE template_id = ".sqlf_tl_num($f_stemplate)." 
			ORDER BY l_name";
 $rs = query($sql);

 if ($rs["num"]) {
 

 for ($i = 0; $i < $rs["num"]; $i++) {
 $tags[$rs["arr"][$i]["name"]] = $rs["arr"][$i]["name"];
 }
 }

 
 $tmp = $HI["sel"];
 $tmp["var"] = "stemplate";
 $tmp["label"] = i18n("source template");
 $tmp["onchange"] = "&changed=stemplate";
 $tmp["optional"] = true;
 $tmp["list"] = $templates;
 $tmp["help"] = i18n("template, on which the pages are based on");
 $hi[] = $tmp;

 
 $tmp = $HI["sel"];
 $tmp["var"] = "dtemplate";
 $tmp["label"] = i18n("destination template");
 $tmp["list"] = $templates;
 $tmp["help"] = i18n("templates, on which the pages are based after an import");
 
 $tmp["optional"] = true;
 $hi[] = $tmp;

 $tmp = $HI["hidden"];
 $tmp["var"] = "cn_import_id";
 $hi[] = $tmp;

 
 $f = $HI["text"];
 $f["label"] = i18n("cn_import_start_path");
 $f["var"] = "cn_import_start_path";
 $f["size"] = 40;
 
 $f["help"] = i18n("The Path from where the import originates");
 
 $f["optional"] = true;
 $hi[] = $f;

 
 $tmp = $HI["sel"];
 $tmp["var"] = "cn_import_pagename";
 $tmp["label"] = i18n("pagename from tag");
 $tmp["list"] = $tags;
 $tmp["help"] = i18n("tag, whose content will be used to name the pages");
 $tmp["optional"] = true;
 $hi[] = $tmp;


 
 if ($perm[8]) {
 
 $tmp = $HI["sel"];
 $tmp["var"] = "cn_import_foldername";
 $tmp["label"] = i18n("foldername from tag");
 $tmp["help"] = i18n("tag, whose content will be used to name the folders");
 $tmp["list"] = $tags;
 $tmp["optional"] = true;
 $hi[] = $tmp;

 $tmp = $HI["checkbox"];
 $tmp["var"] = "keepfolders";
 $tmp["label"] = i18n("keep folder structure");
 $tmp["help"] = i18n("keeps the folderstructure of the startpath and its subdirectories");
 $hi[] = $tmp;
 }

 
 if ($FEATURE["contentgroup3"])
 {
 $folder = get_folderinfo($FOLDER_ID);
 $cg = get_contentgroups ($folder["node_id"]);

 $languages = array();

 while (list($key,$val) = each($cg))
 $languages[$key] = $val["name"];

 $tmp = $HI["sel"];
 $tmp["var"] = "contentgroup";
 $tmp["label"] = i18n("language");
 $tmp["list"] = $languages;
 $tmp["help"] = i18n("language after the import");
 $tmp["optional"] = true;
 
 $contentgroup = $CONTENTGROUP_ID;
 $hi[] = $tmp;
 }
 
 
 $PAGE_STATI[1] = $PAGE_STATI[2];
 unset($PAGE_STATI[2]);

 ksort($PAGE_STATI);

 
 
 
 

 while (list($key,$val) = each($PAGE_STATI)) {
 $PAGE_STATI[$key] = i18n($val);
 }
 
 $tmp = $HI["sel"];
 $tmp["var"] = "status";
 $tmp["label"] = i18n('174.status');
 $tmp["list"] = $PAGE_STATI;
 $tmp["help"] = i18n("pagestate after the import");
 $hi[] = $tmp;

 $tmp = $HI["checkbox"];
 $tmp["var"] = "keepfilename";
 $tmp["help"] = i18n("keep the filename during the import");
 $tmp["label"] = i18n("keep filename");
 $hi[] = $tmp;

 $f = $HI["ok"];
 $f["label"] = i18n("ok");
 $hi[] = $f;

 
 $hi[] = $HI["cancel"];

}
 $f = new htmlform($hi);

if ($faction == "cancel") {

 unset($action);
 unset($hi);
 $REDO = 13011;
} else {

 
 if ((!$f->err() && $faction == "ok") || $PHPSHELL) {
 $javaParser =& CodeParser::getJavaParser();
 
 $javaParser->bufferClearCaches(true);
 $javaParser->bufferEvents(true);

 
 $pagesToPublish = array();

 
 
 $mlp = new ml_page();
 
 if (!$cn_import_id) $cn_import_id = ml_page::_calcImportId();

 
 $logger->start();
 $logger->addText("",true);

 
 @unlink($CN_IMPORT_PATH."/.finished");

 $logger->addText("starting new import (cn_import_id = $cn_import_id)",true);

 if ($stemplate == -9999 || !$stemplate) {
 $f->check["stemplate"] = i18n("an element must be selected!");
 } elseif (!$cn_import_start_path) {
 $f->check["cn_import_start_path"] = i18n("you must choose a file to import");
 } else {
 $CN_IMPORT_KEEPFILENAME = $keepfilename;
 $CN_IMPORT_STATUS= $status;
 mysession_var_reg("CN_IMPORT_KEEPFILENAME");
 mysession_var_reg("CN_IMPORT_PAGENAME");
 mysession_var_reg("CN_IMPORT_FOLDERNMAE");
 
 $filename = $cn_import_start_path;


 
 if (eregi("^(ht|f)tp://",$filename)) {
 
 } elseif (eregi("(\.\.|^/)",$filename)) {
 $filename = eregi_replace("\.\.","",$filename);
 $filename = eregi_replace("/+", "/", "$CN_IMPORT_PATH/$filename");
 } else {
 $filename = eregi_replace("/+", "/", "$CN_IMPORT_PATH/$filename");
 }

 $filename = realpath($filename);
 if (is_dir($filename)) {
 $CN_IMPORT_BASEPATH = $filename;
 } else {
 $CN_IMPORT_BASEPATH = dirname($filename);
 }
 if (is_file($filename)) {
 
 $filelist = array($filename);
 } elseif (is_dir($filename)) {
 
 if ($LOGLEVEL > 0) $logger->addText(date("H:i:s")." - listing files ... ");
 $filelist = listfiles($filename);
 if ($LOGLEVEL > 0) $logger->addText("done",true);

 
 if ($LOGLEVEL > 0) $logger->addText(date("H:i:s")." - listing directories ... ");
 $folderlist = listdirectories($filename);
 if ($LOGLEVEL > 0) $logger->addText("done",true);
 } else {
 
 $filelist = array($filename);
 }

 

 if ($keepfolders && sizeof($folderlist) > 0) {
 
 
 $folderlist[] = $filename;

 if ($LOGLEVEL > 0) $logger->addText(date("H:i:s")." - creating folders ... ");
 
 $CN_IMPORT_FOLDERS = createfolders($FOLDER_ID, $folderlist);
 if ($LOGLEVEL > 0) $logger->addText("done", true);
 }
 
 
 $pagecount = 0;
 $pageerrorcount = 0;
 $errorpages = array();
 $filecount = 0;
 
 
 $logger->addText("",true);
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("starting fileimport",true);
 
 
 $keyed_filelist = array();
 
 reset($filelist);
 foreach($filelist as $filename) {
 $_filetype = strtoupper(getfiletype($filename));
 




 if (file_exists($filename) && is_readable($filename) &&
 !in_array($_filetype, $CN_IMPORT_IGNOREEXTENSION) && !in_array($_filetype, $CN_IMPORT_PAGEEXTENSION)) {

 
 
 if ($keepfolders && $folder_id = $CN_IMPORT_FOLDERS[strtolower(dirname($filename))]["id"]) {
 
 } else {
 $folder_id = $FOLDER_ID;
 }

 
 if ($ML_IMPORT_LOOP_TIMELIMIT) {
 set_time_limit($ML_IMPORT_LOOP_TIMELIMIT);
 } else {
 set_time_limit(60);
 }
 if ($LOGLEVEL > 1) $logger->addText("importing file $filename ... done", true);
 
 $rsfile = importfile($filename, $folder_id, $IMPORT_DIFF);
 $CN_IMPORT_FILES[strtolower($filename)] = $rsfile;
 
 if ($LOGLEVEL == 1 && $rsfile["changed"]) {
 $logger->addText("importing file $filename ... done", true);
 } else if ($LOGLEVEL > 1) {
 $logger->addText($rsfile["changed"] ? "done" : "unchanged", true);
 }

 
 
 $tmpfilename = dirname($filename)."/".preg_replace("/[^0-9a-zA-Z\.\-]/","_",basename($filename));
 $keyed_filelist[strtolower($tmpfilename)] = true;
 
 } else {
 
 
 
 
 $keyed_filelist[strtolower($filename)] = true;
 }

 }

 if ($IMPORT_DIFF && !$SKIP_CLEANUP) {

 $logger->addText("",true);
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("cleaning up files",true);
 
 cleanupfolders($FOLDER_ID, $CN_IMPORT_FOLDERS, $keyed_filelist, $logger, $LOGLEVEL, $CN_IMPORT_BASEPATH);
 }
 
 
 
 global $constructs, $constr, $part_type_id;
 $constructs = array();
 $constr = array();
 $part_type_id = array();
 get_constructs(); 
 
 $logger->addText("",true);
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("starting pageimport",true);
 for ($i = 0; $i < sizeof($filelist); $i++) {
 $filename = $filelist[$i];

 
 

 if (((is_array($CN_IMPORT_USEEXTENSION) && in_array(getfiletype($filename),$CN_IMPORT_USEEXTENSION)) || 
 (!isset($CN_IMPORT_USEEXTENSION) && is_array($CN_IMPORT_IGNOREEXTENSION) && !in_array(getfiletype($filename),$CN_IMPORT_IGNOREEXTENSION))) &&
 $fp = @fopen($filename, "rb")) {

 
 unset($file_data);
 
 while(!feof($fp)) {
 $file_data .= fread ($fp, 4096);
 }
 fclose ($fp);

 
 if ($ML_IMPORT_LOOP_TIMELIMIT) {
 set_time_limit($ML_IMPORT_LOOP_TIMELIMIT);
 } else {
 set_time_limit(61);
 }

 
 
 if ($LOGLEVEL > 1) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("importing $filename ... ");
 }

 
 if ($FEATURE["contentgroup3"] && $contentgroup)
 $result = ml_import($file_data, $stemplate, $logger, $dtemplate, $filename, $cn_import_foldername, $cn_import_pagename, $keepfilename, $keepfolders, $contentgroup, $IMPORT_DIFF);
 
 else
 $result = ml_import($file_data, $stemplate, $logger, $dtemplate, $filename, $cn_import_foldername, $cn_import_pagename, $keepfilename, $keepfolders, 0, $IMPORT_DIFF);


 if ($result < 0) {
 if ($LOGLEVEL > 1) {
 $logger->addText("unchanged",true);
 }
 
 
 $CN_IMPORT_PAGES[$filename]["page_id"] = -$result;
 
 $mlp->init(-$result, $cn_import_id);
 $mlp->setUrl($filename);
 $mlp->save();
 
 } else if ($result) {
 
 $mlp->init($result, $cn_import_id);
 $mlp->setUrl($filename);
 $mlp->save();

 
 if ($LOGLEVEL == 1) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("importing $filename ... ");
 }
 if ($LOGLEVEL > 0) $logger->addText("done",true);
 
 $CN_IMPORT_PAGES[$filename]["page_id"] = $result;
 $pagecount++;

 
 if (!$status) $status = 0;
 if ($status == 1) {
 
 $pagesToPublish[] = $result;
 } else {
 page_status($result, $status, $USER_ID);
 }
 
 } else {
 if ($LOGLEVEL > 1) {
 $logger->addText("error while creating page", true);
 }
 
 $pageerrorcount++;
 $errorpages[] = $filename;
 }
 } elseif (is_array($CN_IMPORT_IGNOREEXTENSION) && in_array(getfiletype($filename),$CN_IMPORT_IGNOREEXTENSION)) {
 if ($LOGLEVEL > 0) $logger->addText("skipping $filename - ignoring (CN_IMPORT_IGNOREEXTENSION)",true);
 
 
 } elseif (!is_readable($filename)) {
 $logger->addText("error reading $filename",true);
 
 } elseif (isset($CN_IMPORT_FILES[strtolower($filename)])) {
 
 if ($LOGLEVEL > 1) $logger->addText(" skipping $filename - file already imported",true);
 } else {
 $logger->addText("skipping $filename - unknown error while processing",true);
 }


 }
 







 


 

 if ((!$result && !$pagecount && !$pageerrorcount) || sizeof($filelist) == 0) {
 $f->check["cn_import_start_path"] = i18n("error_opening_file");
 
 
 } else {
 if ($pageerrorcount > 0) {
 $logger->addText(date("H:i:s")." - error while importing $pageerrorcount pages. check for existing pages/files with identical filename and for data consistency (publish table) -\n\t" . implode("\n\t", $errorpages),true);
 }
 $logger->addText(date("H:i:s")." - successfully imported $pagecount pages",true);
 $message = "";
 if ($pagecount) {
 $message .= "$pagecount ".i18n("files successfully imported");
 $REDO = 13020;
 } else {
 $message .= i18n("no files imported");
 }
 if ($pageerrorcount) {
 $message .= "\\n".i18n("{0} files could not be imported", 0, array($pageerrorcount));
 if($pageerrorcount <= 10) {
 $message .= ": ".str_replace("'", "\\'", implode($errorpages, "\\n"));
 }
 }
 $JS = "alert('$message');";
 }
 }

 reset($CN_IMPORT_FILES);
 foreach ($CN_IMPORT_FILES as $_url => $_file) {
 $mlp->init($_file["id"],$cn_import_id);
 $mlp->setUrl($_url);
 $mlp->save();
 }

 
 reset($CN_IMPORT_PAGES);
 
 



 
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("relinking files/pages ... ");
 foreach ($CN_IMPORT_PAGES as $page => $_ids) {
 $mlp->init($_ids["page_id"], $cn_import_id);
 $mlp->setUrl($page);
 

 if (is_array($_ids["parts"])) {
 

 
 if (isset($_ids["page_id"]) || is_array($CN_IMPORT_FILES[strtolower($page)])) {
 

 
 foreach ($_ids["parts"] as $parts_id => $parts) {

 $tmp = "p".$parts["part_id"]."_a";
 $tmp1 = "p".$parts["part_id"]."_c";

 if (isset($_ids["page_id"])) {
 
 $val = $_ids["page_id"];
 } elseif (isset($CN_IMPORT_FILES[strtolower($page)]["id"])) {
 
 
 $val = $CN_IMPORT_FILES[strtolower($page)]["id"];
 }
 $val1 = "a";

 global $$tmp, $$tmp1;
 $$tmp = $val;
 $$tmp1 = $val1;

 
 
 
 part_update($parts["part_id"],$parts["type_id"],$parts["cid"],$parts["editable"],$parts["type"],$parts["tag_id"],true,false,false);
 }

 } else {
 
 
 foreach ($_ids["parts"] as $parts) {
 
 
 $mlp->addPart($parts["tag_id"], $parts["part_id"], $parts["type_id"]);
 }
 }
 }

 
 if (isset($mlp) && $mlp->url) {
 if ($mlp->save()) {
 
 


 } else {
 
 }
 }


 }

 
 $sql = "DELETE FROM import_page";
 query($sql);
 $sql = "DELETE FROM import_part";
 query($sql);

 
 if ($REDO) {
 $JS .= "reload_tree();\n";

 
 $fp_finished = @fopen($CN_IMPORT_PATH."/.finished","w+");
 fclose($fp_finished);
 }

 $logger->addText("done", true);

 $logger->addText(date("H:i:s")." - flushing buffered triggerevent calls and clearing caches ... ");
 $javaParser->bufferClearCaches(false);
 $javaParser->bufferEvents(false);
 $logger->addText("done", true);

 
 $pagesToPublishCount = count($pagesToPublish);
 if ($pagesToPublishCount > 0) {
 $logger->addText(date("H:i:s")." - publishing " . $pagesToPublishCount . " pages ... ");

 foreach ($pagesToPublish as $pageToPublish) {
 cmd_page_pub($pageToPublish);
 }

 $logger->addText("done", true);
 }

 $logger->addText(date("H:i:s"), true);

 if ($PHPSHELL) {
 die ("imported $pagecount pages\n");
 }

 $logger->stop();
 }
}


load_menu(11001, $T_FOLDER, $FOLDER_ID);
